/*******************************************************************************
 * Copyright (c) 2007 Supelec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This file is part of the ADLV tool
 * Version 1.0 (December 5, 2007)
 *
 * Contributors:
 *     Computer Science Department, Supelec : initial implementation
 * Contacts:
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *******************************************************************************/
package fr.supelec.adlv.checker;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

public class Signal {
	public final PortInstance port;

	/**
	 * Indicates if the signal is considered positively or negatively
	 */
	public final boolean positive;

	public Signal(PortInstance port, boolean positive) {
		this.port = port;
		this.positive = positive;
	}

	@Override
	public String toString() {
		return (positive ? "+" : "-") + port;
	}

	public static Set<Signal> positiveSignalsFromPorts(Collection<PortInstance> ports) {
		Set<Signal> res = new HashSet<Signal>(ports.size());
		for(PortInstance port : ports) {
			res.add(new Signal(port, true));
		}
		return res;
	}
}
