/*******************************************************************************
 * Copyright (c) 2007 Supelec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This file is part of the ADLV tool
 * Version 1.0 (December 5, 2007)
 *
 * Contributors:
 *     Computer Science Department, Supelec : initial implementation
 * Contacts:
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *******************************************************************************/
package fr.supelec.adlv.checker.logic;

public enum ComparisonOperator {
	LESS("<", null), GREATER(">", null), EQUAL("==", null),
	GEQ(">=", LESS), LEQ("<=", GREATER), NEQ("!=", EQUAL);

	private final String symbol;
	private ComparisonOperator negation;
	
	private ComparisonOperator(String symbol, ComparisonOperator negation) {
		this.symbol = symbol;
		this.negation = negation;
	}
	
	public ComparisonOperator neg() {
		return negation;
	}
	
	public String toString() {
		return symbol;
	}
	
	static {
		for(ComparisonOperator co : ComparisonOperator.values()) {
			if(co.negation != null) co.negation.negation = co;
		}
		//	
		//for(ComparisonOperator co : ComparisonOperator.values()) {
		//	System.out.println(co + " neg " + co.neg());
		//}
	}
}
