/*******************************************************************************
 * Copyright (c) 2007 Supelec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This file is part of the ADLV tool
 * Version 1.0 (December 5, 2007)
 *
 * Contributors:
 *     Computer Science Department, Supelec : initial implementation
 * Contacts:
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *******************************************************************************/
package fr.supelec.adlv.checker.logic;

public class NaryAnd extends NaryExpr {
	@Override
	public String toString() {
		return toString("&&");
	}

	@Override
	public Expr simplify() {
		NaryAnd sAnd = new NaryAnd();

		// eliminate constants
		for(Expr e : operands) {
			e = e.simplify();
			if(e instanceof Constant) {
				Constant c = (Constant)e;
				if(!c.getValue()) {
					return Constant.FALSE;
				} // else do nothing, not even keep it in the operand set
			} else sAnd.add(e);
		}
		// a AND among 0 terms is TRUE
		if(sAnd.operands.size() == 0) return Constant.TRUE;

		// check for inverse predicates (a and !a)
		if(containsInversePredicates()) return Constant.FALSE;

		return sAnd;
	}
}
