/*******************************************************************************
 * Copyright (c) 2007 Supelec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This file is part of the ADLV tool
 * Version 1.0 (December 5, 2007)
 *
 * Contributors:
 *     Computer Science Department, Supelec : initial implementation
 * Contacts:
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *******************************************************************************/
package fr.supelec.adlv.checker.logic;


public abstract class Predicate extends Expr {
	public abstract Predicate neg();
	public abstract boolean isNegationOf(Predicate p);

	@Override
	public void accept(ExprVisitor visitor) {
		throw new RuntimeException(
				"Missing implementation of accept() for Predicate subclass \""
				+ getClass().getName() + "\" or accept() should not be called "
				+ "on this subclass.");
	}

	@Override
	public Expr simplify() {
		return this;
	}

	@Override
	protected Expr develop(boolean cnf) {
		return this;
	}

	@Override
	public boolean isTemporal() {
		return false;
	}

	@Override
	public ExprBundle getBundle() {
		// default version for predicates -- except ProtoInterval!
		return new ExprBundle(this, this, false);
	}
}
