/*******************************************************************************
 * Copyright (c) 2007 Supelec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This file is part of the ADLV tool
 * Version 1.0 (December 5, 2007)
 *
 * Contributors:
 *     Computer Science Department, Supelec : initial implementation
 * Contacts:
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *******************************************************************************/
package fr.supelec.adlv.checker.logic;

import java.util.Set;

import fr.supelec.adlv.checker.PortInstance;

public class ProtoInterval extends Predicate {
	private final Interval inner, outer;

	public ProtoInterval(Interval inner, Interval outer) {
		this.inner = inner;
		this.outer = outer;
	}

	public Interval getInner() {
		return inner;
	}

	public Interval getOuter() {
		return outer;
	}

	@Override
	public String toString() {
		return "{PROTO: inner=" + inner + "; outer=" + outer + " }";
	}

	@Override
	public boolean isNegationOf(Predicate p) {
		throw new RuntimeException("Should not call isNegationOf() on a proto-interval!");
	}

	@Override
	public Predicate neg() {
		throw new RuntimeException("Should not call neg() on a proto-interval!");
	}

	@Override
	public Set<PortInstance> getInputSignals() {
		throw new RuntimeException("Should not call getInputSignals() on a proto-interval!");
	}

	@Override
	public Expr develop(boolean cnf) {
		throw new RuntimeException("Should not call develop() on a proto-interval!");
	}

	@Override
	public ExprBundle getBundle() {
		return new ExprBundle(inner, outer, true);
	}
}
