/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Application</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.adlv.Application#getName <em>Name</em>}</li>
 *   <li>{@link fr.supelec.adlv.Application#getPorts <em>Ports</em>}</li>
 *   <li>{@link fr.supelec.adlv.Application#getModule <em>Module</em>}</li>
 *   <li>{@link fr.supelec.adlv.Application#getInitialSteps <em>Initial Steps</em>}</li>
 *   <li>{@link fr.supelec.adlv.Application#getOutputConnection <em>Output Connection</em>}</li>
 *   <li>{@link fr.supelec.adlv.Application#getInputConnection <em>Input Connection</em>}</li>
 *   <li>{@link fr.supelec.adlv.Application#getComponents <em>Components</em>}</li>
 *   <li>{@link fr.supelec.adlv.Application#getSafetyClause <em>Safety Clause</em>}</li>
 *   <li>{@link fr.supelec.adlv.Application#getStaticConfiguration <em>Static Configuration</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.adlv.AdlvPackage#getApplication()
 * @model
 * @generated
 */
public interface Application extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see fr.supelec.adlv.AdlvPackage#getApplication_Name()
	 * @model unique="false" required="true" ordered="false"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Application#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Ports</b></em>' containment reference list.
	 * The list contents are of type {@link fr.supelec.adlv.Port}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Port#getApplication <em>Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ports</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Ports</em>' containment reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getApplication_Ports()
	 * @see fr.supelec.adlv.Port#getApplication
	 * @model opposite="application" containment="true" ordered="false"
	 * @generated
	 */
	EList<Port> getPorts();

	/**
	 * Returns the value of the '<em><b>Module</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Module#getApplication <em>Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Module</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Module</em>' container reference.
	 * @see #setModule(Module)
	 * @see fr.supelec.adlv.AdlvPackage#getApplication_Module()
	 * @see fr.supelec.adlv.Module#getApplication
	 * @model opposite="application" required="true" transient="false" ordered="false"
	 * @generated
	 */
	Module getModule();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Application#getModule <em>Module</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Module</em>' container reference.
	 * @see #getModule()
	 * @generated
	 */
	void setModule(Module value);

	/**
	 * Returns the value of the '<em><b>Initial Steps</b></em>' containment reference list.
	 * The list contents are of type {@link fr.supelec.adlv.ConfigurationStep}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.ConfigurationStep#getApplication <em>Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Initial Steps</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Initial Steps</em>' containment reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getApplication_InitialSteps()
	 * @see fr.supelec.adlv.ConfigurationStep#getApplication
	 * @model opposite="application" containment="true" ordered="false"
	 * @generated
	 */
	EList<ConfigurationStep> getInitialSteps();

	/**
	 * Returns the value of the '<em><b>Output Connection</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.adlv.Connection}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Connection#getFromApplication <em>From Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Output Connection</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Output Connection</em>' reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getApplication_OutputConnection()
	 * @see fr.supelec.adlv.Connection#getFromApplication
	 * @model opposite="fromApplication" ordered="false"
	 * @generated
	 */
	EList<Connection> getOutputConnection();

	/**
	 * Returns the value of the '<em><b>Input Connection</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.adlv.Connection}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Connection#getToApplication <em>To Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Input Connection</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Input Connection</em>' reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getApplication_InputConnection()
	 * @see fr.supelec.adlv.Connection#getToApplication
	 * @model opposite="toApplication" ordered="false"
	 * @generated
	 */
	EList<Connection> getInputConnection();

	/**
	 * Returns the value of the '<em><b>Components</b></em>' containment reference list.
	 * The list contents are of type {@link fr.supelec.adlv.Component}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Component#getApplication <em>Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Components</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Components</em>' containment reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getApplication_Components()
	 * @see fr.supelec.adlv.Component#getApplication
	 * @model opposite="application" containment="true" ordered="false"
	 * @generated
	 */
	EList<Component> getComponents();

	/**
	 * Returns the value of the '<em><b>Safety Clause</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.adlv.SafetyClause}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Safety Clause</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Safety Clause</em>' reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getApplication_SafetyClause()
	 * @model ordered="false"
	 * @generated
	 */
	EList<SafetyClause> getSafetyClause();

	/**
	 * Returns the value of the '<em><b>Static Configuration</b></em>' containment reference list.
	 * The list contents are of type {@link fr.supelec.adlv.ConfigurationStep}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Static Configuration</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Static Configuration</em>' containment reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getApplication_StaticConfiguration()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<ConfigurationStep> getStaticConfiguration();

} // Application
