/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Component</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.adlv.Component#getName <em>Name</em>}</li>
 *   <li>{@link fr.supelec.adlv.Component#getComponentConfigurationStep <em>Component Configuration Step</em>}</li>
 *   <li>{@link fr.supelec.adlv.Component#getInputConnection <em>Input Connection</em>}</li>
 *   <li>{@link fr.supelec.adlv.Component#getOutputConnection <em>Output Connection</em>}</li>
 *   <li>{@link fr.supelec.adlv.Component#getApplication <em>Application</em>}</li>
 *   <li>{@link fr.supelec.adlv.Component#getConsumerPortExpression <em>Consumer Port Expression</em>}</li>
 *   <li>{@link fr.supelec.adlv.Component#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.adlv.AdlvPackage#getComponent()
 * @model
 * @generated
 */
public interface Component extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see fr.supelec.adlv.AdlvPackage#getComponent_Name()
	 * @model unique="false" required="true" ordered="false"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Component#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Component Configuration Step</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.adlv.ComponentConfigurationStep}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.ComponentConfigurationStep#getComponent <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Component Configuration Step</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Component Configuration Step</em>' reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getComponent_ComponentConfigurationStep()
	 * @see fr.supelec.adlv.ComponentConfigurationStep#getComponent
	 * @model opposite="component" ordered="false"
	 * @generated
	 */
	EList<ComponentConfigurationStep> getComponentConfigurationStep();

	/**
	 * Returns the value of the '<em><b>Input Connection</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.adlv.Connection}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Connection#getToComponent <em>To Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Input Connection</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Input Connection</em>' reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getComponent_InputConnection()
	 * @see fr.supelec.adlv.Connection#getToComponent
	 * @model opposite="toComponent" ordered="false"
	 * @generated
	 */
	EList<Connection> getInputConnection();

	/**
	 * Returns the value of the '<em><b>Output Connection</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.adlv.Connection}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Connection#getFromComponent <em>From Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Output Connection</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Output Connection</em>' reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getComponent_OutputConnection()
	 * @see fr.supelec.adlv.Connection#getFromComponent
	 * @model opposite="fromComponent" ordered="false"
	 * @generated
	 */
	EList<Connection> getOutputConnection();

	/**
	 * Returns the value of the '<em><b>Application</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Application#getComponents <em>Components</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Application</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Application</em>' container reference.
	 * @see #setApplication(Application)
	 * @see fr.supelec.adlv.AdlvPackage#getComponent_Application()
	 * @see fr.supelec.adlv.Application#getComponents
	 * @model opposite="components" required="true" transient="false" ordered="false"
	 * @generated
	 */
	Application getApplication();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Component#getApplication <em>Application</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Application</em>' container reference.
	 * @see #getApplication()
	 * @generated
	 */
	void setApplication(Application value);

	/**
	 * Returns the value of the '<em><b>Consumer Port Expression</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.adlv.PortExpression}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.PortExpression#getComponent <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Consumer Port Expression</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Consumer Port Expression</em>' reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getComponent_ConsumerPortExpression()
	 * @see fr.supelec.adlv.PortExpression#getComponent
	 * @model opposite="component" ordered="false"
	 * @generated
	 */
	EList<PortExpression> getConsumerPortExpression();

	/**
	 * Returns the value of the '<em><b>Type</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.ComponentType#getComponent <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' reference.
	 * @see #setType(ComponentType)
	 * @see fr.supelec.adlv.AdlvPackage#getComponent_Type()
	 * @see fr.supelec.adlv.ComponentType#getComponent
	 * @model opposite="component" required="true" ordered="false"
	 * @generated
	 */
	ComponentType getType();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Component#getType <em>Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' reference.
	 * @see #getType()
	 * @generated
	 */
	void setType(ComponentType value);

} // Component
