/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv.impl;

import fr.supelec.adlv.AdlvPackage;
import fr.supelec.adlv.Application;
import fr.supelec.adlv.ConfigurationStep;
import fr.supelec.adlv.ConsumerPort;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Configuration Step</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.adlv.impl.ConfigurationStepImpl#getApplication <em>Application</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ConfigurationStepImpl#getStateTransition <em>State Transition</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class ConfigurationStepImpl extends EObjectImpl implements ConfigurationStep {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConfigurationStepImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AdlvPackage.Literals.CONFIGURATION_STEP;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Application getApplication() {
		if (eContainerFeatureID != AdlvPackage.CONFIGURATION_STEP__APPLICATION) return null;
		return (Application)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetApplication(Application newApplication, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newApplication, AdlvPackage.CONFIGURATION_STEP__APPLICATION, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setApplication(Application newApplication) {
		if (newApplication != eInternalContainer() || (eContainerFeatureID != AdlvPackage.CONFIGURATION_STEP__APPLICATION && newApplication != null)) {
			if (EcoreUtil.isAncestor(this, newApplication))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newApplication != null)
				msgs = ((InternalEObject)newApplication).eInverseAdd(this, AdlvPackage.APPLICATION__INITIAL_STEPS, Application.class, msgs);
			msgs = basicSetApplication(newApplication, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.CONFIGURATION_STEP__APPLICATION, newApplication, newApplication));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConsumerPort getStateTransition() {
		if (eContainerFeatureID != AdlvPackage.CONFIGURATION_STEP__STATE_TRANSITION) return null;
		return (ConsumerPort)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStateTransition(ConsumerPort newStateTransition, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newStateTransition, AdlvPackage.CONFIGURATION_STEP__STATE_TRANSITION, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStateTransition(ConsumerPort newStateTransition) {
		if (newStateTransition != eInternalContainer() || (eContainerFeatureID != AdlvPackage.CONFIGURATION_STEP__STATE_TRANSITION && newStateTransition != null)) {
			if (EcoreUtil.isAncestor(this, newStateTransition))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newStateTransition != null)
				msgs = ((InternalEObject)newStateTransition).eInverseAdd(this, AdlvPackage.CONSUMER_PORT__STEPS, ConsumerPort.class, msgs);
			msgs = basicSetStateTransition(newStateTransition, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.CONFIGURATION_STEP__STATE_TRANSITION, newStateTransition, newStateTransition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.CONFIGURATION_STEP__APPLICATION:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetApplication((Application)otherEnd, msgs);
			case AdlvPackage.CONFIGURATION_STEP__STATE_TRANSITION:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetStateTransition((ConsumerPort)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.CONFIGURATION_STEP__APPLICATION:
				return basicSetApplication(null, msgs);
			case AdlvPackage.CONFIGURATION_STEP__STATE_TRANSITION:
				return basicSetStateTransition(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID) {
			case AdlvPackage.CONFIGURATION_STEP__APPLICATION:
				return eInternalContainer().eInverseRemove(this, AdlvPackage.APPLICATION__INITIAL_STEPS, Application.class, msgs);
			case AdlvPackage.CONFIGURATION_STEP__STATE_TRANSITION:
				return eInternalContainer().eInverseRemove(this, AdlvPackage.CONSUMER_PORT__STEPS, ConsumerPort.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdlvPackage.CONFIGURATION_STEP__APPLICATION:
				return getApplication();
			case AdlvPackage.CONFIGURATION_STEP__STATE_TRANSITION:
				return getStateTransition();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdlvPackage.CONFIGURATION_STEP__APPLICATION:
				setApplication((Application)newValue);
				return;
			case AdlvPackage.CONFIGURATION_STEP__STATE_TRANSITION:
				setStateTransition((ConsumerPort)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AdlvPackage.CONFIGURATION_STEP__APPLICATION:
				setApplication((Application)null);
				return;
			case AdlvPackage.CONFIGURATION_STEP__STATE_TRANSITION:
				setStateTransition((ConsumerPort)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdlvPackage.CONFIGURATION_STEP__APPLICATION:
				return getApplication() != null;
			case AdlvPackage.CONFIGURATION_STEP__STATE_TRANSITION:
				return getStateTransition() != null;
		}
		return super.eIsSet(featureID);
	}

} //ConfigurationStepImpl
