/*******************************************************************************
 * Copyright (c) 2007 Supelec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This file is part of the ADLV tool
 * Version 1.0 (December 5, 2007)
 *
 * Contributors:
 *     Computer Science Department, Supelec : initial implementation
 * Contacts:
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *******************************************************************************/
package fr.supelec.adlv.generator;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.FileNotFoundException;

import fr.supelec.adlv.parser.EmfAdlvFeeder;

public class TestGenerator {
	
	public static void main( String[] args ) {
		System.out.println( "Debut..." );
		
		BufferedInputStream input = null;
		try {
			input = new BufferedInputStream( new FileInputStream( "../SpeedRegul/SpeedControl.adlv" ));
		}
		catch( FileNotFoundException ex ) {
			System.err.println( "ADLV file not found : " + ex.toString() );
			return;
		}
		
		EmfAdlvFeeder feeder = new EmfAdlvFeeder();
		if( ! feeder.parse( input )) {
			return;
		}
		
		EventTypeGenerator etg = new EventTypeGenerator( feeder.getHelper() );
 		try {
			etg.generate( "SpeedControlModule", "../results" );
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		
		MpcGenerator mg = new MpcGenerator( feeder.getHelper() );
 		try {
			mg.generate( "../results" );
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		
		Idl3Generator ig = new Idl3Generator( feeder.getHelper() );
		try {
			ig.generate( "../results" );
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		
		CppGenerator cg = new CppGenerator( feeder.getHelper() );
		try {
			cg.generate( "../results" );
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		
		InternalComponentImplGenerator img = new InternalComponentImplGenerator( feeder.getHelper() );
		try {
			img.generate( "../results" );
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		
		ApplicationComponentImplGenerator acg = new ApplicationComponentImplGenerator( feeder.getHelper() );
		try {
			acg.generate( "../results" );
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		
		CcdGenerator ccg = new CcdGenerator( feeder.getHelper() );
		try {
			ccg.generate( "../results" );
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		
		System.out.println( "Fin !" );
	}	
}
